#include <iostream>
#include <deque>
#include <vector>
#include <utility>
#include <map>
#include <algorithm>
#include <string>
using namespace std;

char steps[] = { 'u','d','l','r','U','D','L','R' };

typedef pair<int,int> box;
typedef vector<box> boxes;
typedef pair<box,boxes> position; 

deque<position> Q; 
vector< vector<int> > M;
map<position,int> WAS, HOW;
boxes SOL;
position WHERE;
int done=0;

int compress(int dx, int dy, int box) { int res=4*box; if (dy==0) return res+((dx+1)/2); return res+2+((dy+1)/2); }

void UndoMove(position *HERE, int move) {
  int dx,dy,isbox; 
  box *P=&(HERE->first);
  boxes *B=&(HERE->second);
  boxes::iterator bit;
  
  isbox=move/4; move%=4; if (move<2) { dx=2*move-1; dy=0; } else { move-=2; dy=2*move-1; dx=0; }
  (P->first)-=dx; (P->second)-=dy;
  
  if (isbox) { 
    box BB=box(P->first + 2*dx, P->second + 2*dy);
    bit=find(B->begin(),B->end(),BB);
    (bit->first)-=dx; (bit->second)-=dy;
    sort(B->begin(),B->end());
  }
}

void WriteSolution(position *FINAL) {
  string solution;
  int sl;

  // alokujeme priestor na ulozenie riesenia
  sl=WAS[*FINAL]; solution.resize(sl); 
  // spaetnym prechodom najdeme riesenie
  for (int i=0;i<sl;i++) { solution[sl-i-1]=steps[HOW[*FINAL]]; UndoMove(FINAL,HOW[*FINAL]); }
  cout << solution << endl;
}

void TryMove(position *NOW, int dx, int dy) {
  box BB,*P=&(NOW->first);
  boxes *B=&(NOW->second);
  boxes::iterator bit;
  int steps=WAS[*NOW];

  if (M[P->first+dx][P->second+dy]==1) return; // tym smerom je stena, nehybeme sa
  
  if (find(B->begin(),B->end(),box(P->first+dx,P->second+dy))!=B->end()) { // tym smerom je kocka
    
    if (M[P->first+2*dx][P->second+2*dy]==1) return; // za kockou je stena
    BB=box(P->first+2*dx,P->second+2*dy); if (find(B->begin(),B->end(),BB)!=B->end()) return; // za kockou je kocka
    
    // za kockou je volno, posunieme kocku
    box BB=box(P->first+dx,P->second+dy);
    bit=find(B->begin(),B->end(),BB);
    (bit->first)+=dx; (bit->second)+=dy;
    sort(B->begin(),B->end());
    
    // nova pozicia sa ulozi do fronty 
    position NEXT(box(P->first+dx,P->second+dy),*B); 
    map<position,int>::iterator mit=WAS.find(NEXT);
    if (mit==WAS.end()) { Q.push_back(NEXT); WAS[NEXT]=steps+1; HOW[NEXT]=compress(dx,dy,1); }  
    
    // ak sme nasli riesenie, skoncime
    if ((*B)==SOL) { done=1; cout << (steps+1) << endl; WriteSolution(&NEXT); return; }
    
    // vratime aktualnu poziciu do povodneho stavu
    bit=find(B->begin(),B->end(),box(P->first+2*dx,P->second+2*dy));
    (bit->first)-=dx; (bit->second)-=dy;
    sort(B->begin(),B->end());
    
  } else { // tym smerom je volno, pohneme sa
    
    if ((*B)==SOL) { done=1; cout << (steps+1) << endl; return; }
    position NEXT(box(P->first+dx,P->second+dy),*B); 
    map<position,int>::iterator mit=WAS.find(NEXT);
    if (mit==WAS.end()) { Q.push_back(NEXT); WAS[NEXT]=steps+1; HOW[NEXT]=compress(dx,dy,0); }  
    
  }
}

int main(void) {
  box P; boxes B; string S;
  
  M.clear(); 
  int i=0;
  while (1) {
    if (!getline(cin,S)) break;
    int sl=S.length(); while (1) { if (sl==0) break; if (S[sl-1]<32) sl--; else break; } // divne konce riadkov

    M.resize(i+1); // pridame novy riadok mapy
    for (int j=0;j<sl;j++) {
      switch (S[j]) {
        case '#': M[i].push_back(1); break; // stena
        case '_': M[i].push_back(0); break; // volno
        case ' ': M[i].push_back(0); break; // volno
        case '.': M[i].push_back(2); SOL.push_back(box(i,j)); break; // ciel
        case '*': M[i].push_back(2); B.push_back(box(i,j)); SOL.push_back(box(i,j)); break; // kocka na cieli
        case '$': M[i].push_back(0); B.push_back(box(i,j)); break; // kocka
        case '@': M[i].push_back(0); P=box(i,j); break; // panak
        case '+': M[i].push_back(2); SOL.push_back(box(i,j)); P=box(i,j); break; // panak na cieli
      }
    }
    i++; // zvacsil sa pocet riadkov
  }
  sort(B.begin(),B.end()); sort(SOL.begin(),SOL.end()); // len aby bolo jasne, ze su utriedene 
  WHERE=position(P,B); Q.push_back(WHERE); WAS[WHERE]=0; HOW[WHERE]=-1;
  if (WHERE.second==SOL) { cout << 0 << endl; return 0; } // niet co riesit
  while (!Q.empty()) {
    WHERE=Q.front(); Q.pop_front();
    TryMove(&WHERE,-1,0); if (done) return 0;
    TryMove(&WHERE,1,0); if (done) return 0;
    TryMove(&WHERE,0,-1); if (done) return 0;
    TryMove(&WHERE,0,1); if (done) return 0;
  }
  cout << -1 << endl; // neda sa
  return 0;
}
